import torch
from torch import nn
from torch.autograd import Variable

if torch.cuda.is_available():
    print('Using cuda')
else:
    print('Cuda not found!')
    exit(0)

BATCH_SIZE = 500
INPUT_SIZE = 334
HIDDEN_SIZE = 250
OUTPUT_SIZE = 10
NUM_STEPS = 50000
PRINT_EVERY = 1000

inputs = Variable(torch.normal(means=torch.randn(BATCH_SIZE, INPUT_SIZE),
                  std=0.2)).cuda()
targets = Variable((torch.rand(BATCH_SIZE
                             ) * (OUTPUT_SIZE - 1)).round_().type(
                             torch.LongTensor)).cuda()

class Net(nn.Module):
    def __init__(self, n_input, n_hidden, n_output):
        super(Net, self).__init__()
        self.fc1 = nn.Linear(n_input, n_hidden)
        self.fc2 = nn.Linear(n_hidden, n_hidden)
        self.fc3 = nn.Linear(n_hidden, n_output)

    def forward(self, x):
        h = nn.functional.relu(self.fc1(x))
        h = nn.functional.relu(self.fc2(h))
        return self.fc3(h)

model = Net(INPUT_SIZE, HIDDEN_SIZE, OUTPUT_SIZE)
model.cuda()

criterion = nn.CrossEntropyLoss()
optim = torch.optim.Adam(model.parameters())

for step in range(1, NUM_STEPS + 1):
    optim.zero_grad()
    logits = model(inputs)
    loss = criterion(logits, targets)
    loss.backward()
    optim.step()
    if step % PRINT_EVERY == 0:
        print(loss)
